using Frontend.Assets;
using Frontend.Marketplaces.Interfaces;

namespace Frontend.Marketplaces;

public class PotatoMarketplaceMock() : IPotatoMarketPlace
{
    private const double potatoKgPrice = 2.02; // source: https://www.blw.admin.ch/blw/de/home/markt/marktbeobachtung/kartoffeln.html

    public double PotatoPrice => potatoKgPrice;

    public double ChfToPotatoKg(double chf)
    {
        return chf / potatoKgPrice;
    }

    public double PotatoKgToChf(double kg)
    {
        return kg * potatoKgPrice;
    }

    public PotatoTransaction Buy(double amountInChf)
    {
        var amountInKg = ChfToPotatoKg(amountInChf);
        return new() { Weight = amountInKg };
    }

    public double Sell(PotatoTransaction transaction)
    {
        return PotatoKgToChf(transaction.Weight);
    }
}
