

# Project Plan: Roesticoin - A Stablecoin on the Ethereum Blockchain


## Getting all running
when switching between Devcontainer and production, rebuild the container, because the base image is different
### For development in Devcontainer
- open in VS Code
- add and modify `.env` file based on `.env.sample`
- reopen in container
### As release in Production
- add and modify `.env` file based on `.env.sample`
- `docker-compose -f docker-compose.yml -f docker-compose.release.yml up --build -d`


## Project Title:  
**Roesticoin: Swiss Franc-Pegged Stablecoin on Ethereum**



## Team:  
- Andri Joos

- David Hintermann

- Davor Lucic



## Objective:  
The goal of this project is to design and implement **Roesticoin**, a stablecoin pegged to the Swiss Franc 

(CHF) on the Ethereum blockchain. The coin will be implemented using **.NET technologies** for smart contract development and integration. The stablecoin will ensure stability through 1:1 collateralization with CHF and aim to serve as a reliable means of exchange.



## Deliverables:  
1. **Roesticoin Smart Contract**: An Ethereum-based ERC-20 token with functionality for minting, burning, and transferring tokens.  
2. **Backend System**: A .NET-based system that integrates with the Ethereum blockchain to manage the issuance and redemption of Roesticoin, and interfaces with the Swiss Franc.
3. **Frontend Application**: A user-friendly interface for interacting with Roesticoin, allowing users to manage their tokens via a web-based dashboard.

<img src="overview.png">

## Technologies:  
- Blockchain: **Ethereum**
- Smart Contract Language: **Solidity** (with .NET interoperability)
- Backend: **.NET**
  - **Nethereum**
- Frontend: **ASP.NET** for web development
- Testing: **Remix IDE**, **Nethereum** for Ethereum blockchain testing



## Risk Management:
- **Blockchain Gas Fees**: Ensure the contract is optimized for gas efficiency.
- **Security Vulnerabilities**: Conduct smart contract audits and testing to prevent issues like reentrancy attacks.
- **Currency Peg Stability**: Implement mechanisms to monitor CHF collateral and ensure accurate pegging.



## Evaluation Criteria:
- Functionality of Roesticoin as a stablecoin pegged to CHF.
- Successful deployment on Ethereum with full integration in .NET.
- User interface and ease of interaction through the web dashboard.
- Security and efficiency of smart contract code.

